IO.read doesn't validate the offset argument

01/26/2023 02:09 PM - andrykonchin (Andrew Konchin)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 3.1.3 Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:

UNKNOWN, 3.2: UNKNOWN

Description

I've noticed that when passed negative offset argument IO.read raises a bit confusing error:

IO.read("read-test.txt", 1, -1)

# (irb):55:in `read': Invalid argument @ rb_io_seek - read-test.txt (Errno::EINVAL)

 But error for invalid length argument is much more helpful:

IO.read("read-test.txt", -1)

# (irb):56:in `read': negative length -1 given (ArgumentError)

 I would expect a similar ArgumentError exception to be raised for invalid offset argument instead of Invalid argument @ rb_io_seek -

read-test.txt (Errno::EINVAL)

Associated revisions

Revision 6c60006de5cfd75f10a1b4a3d822e2de41d22db6 - 03/24/2023 07:29 PM - jeremyevans (Jeremy Evans)

Raise ArgumentError if IO.read is provided negative offset

Fixes [Bug #19380]

Revision 6c60006de5cfd75f10a1b4a3d822e2de41d22db6 - 03/24/2023 07:29 PM - jeremyevans (Jeremy Evans)

Raise ArgumentError if IO.read is provided negative offset

Fixes [Bug #19380]

Revision 6c60006d - 03/24/2023 07:29 PM - jeremyevans (Jeremy Evans)

Raise ArgumentError if IO.read is provided negative offset

Fixes [Bug #19380]

History

#1 - 02/10/2023 09:17 PM - jeremyevans0 (Jeremy Evans)

I've submitted a pull request to fix this: https://github.com/ruby/ruby/pull/7289

#2 - 03/24/2023 07:29 PM - jeremyevans (Jeremy Evans)

- Status changed from Open to Closed

Applied in changeset git|6c60006de5cfd75f10a1b4a3d822e2de41d22db6.

Raise ArgumentError if IO.read is provided negative offset

Fixes [Bug #19380]
